<%@ page import="org.apache.commons.fileupload.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%

System.out.println("entry...");

// Check that we have a file upload request
boolean isMultipart = FileUpload.isMultipartContent(request);

if (!isMultipart) {

	boolean upload_end = "END".equals(request.getHeader("X-VAULT-DATA"));

	if (upload_end) {

		out.println("Complete.");

		//process end uploading here

	}

	else {
		// some incorrect request was sent
		out.println ("Use multipart form to upload a file!");
	}

} else {


// Create a new file upload handler
DiskFileUpload upload = new DiskFileUpload();

// Set upload parameters
//upload.setSizeThreshold(yourMaxMemorySize);
//upload.setSizeMax(yourMaxRequestSize);
//upload.setRepositoryPath(yourTempDirectory);

// Parse the request

List /* FileItem */ items = upload.parseRequest(request);

boolean append = !"NEW".equals(request.getHeader("X-VAULT-DATA"));


String uploadBase = "c:\\upload\\";

// Process the uploaded items
Iterator iter = items.iterator();
while (iter.hasNext()) {
    FileItem item = (FileItem) iter.next();

    if (item.isFormField()) {

      if ("X-VAULT-EMPTYFOLDERS".equals(item.getFieldName())) {
				// create empty folders here

				final String CRLF="\n";
				String emptyFolders = item.getString();

				while(emptyFolders!=null && emptyFolders.length()>0) {
					String folderName;
					int c = emptyFolders.indexOf(CRLF);
					if (c>-1) {
						folderName=emptyFolders.substring(0,c);
						emptyFolders=emptyFolders.substring(c+CRLF.length());
					} else {
						folderName=emptyFolders;
						emptyFolders=null;
					}
					int i1 = folderName.indexOf(":");
					if(i1>-1) folderName = folderName.substring(0,i1)+folderName.substring(i1+1);

					File dirs = new File(uploadBase+folderName);
					dirs.mkdirs();
				}

			}
			
      //processFormField
			out.println("alert('field: "+item.getFieldName()+" = "+item.getString()+"');");
    } else {
      //processUploadedFile
    	String fieldName = item.getFieldName();  // we use it to send the short file path
	    String fileName = item.getName();


			int i1 = fieldName.indexOf(":");
			if(i1>-1) fieldName = fieldName.substring(0,i1)+fieldName.substring(i1+1);

			int i2 = fieldName.lastIndexOf("\\");
			if(i2>-1) fieldName = fieldName.substring(0,i2+1); else fieldName = "";

			File dirs = new File(uploadBase+fieldName);
			dirs.mkdirs();

			InputStream is = item.getInputStream();
			FileOutputStream fos = new FileOutputStream(dirs+File.separator+fileName,append);

			byte [] buf = new byte[1024*4];
			int br = 0, n;

			long contentLength = item.getSize();

			while(true)
			{
				if (contentLength!=-1)
					if (br >= contentLength)
						break;
	     	n = is.read(buf);
				if (n>0)
				{
					fos.write(buf, 0, n);
					br += n;
				}
				if(n==-1)
				{
					if (contentLength==-1)
						break;
				}
			}
			is.close();
			fos.close();

			out.println("alert('file');");
	  }
		//out.println("location.replace('./index.jsp')");
}

} //multipart
%>